angular.module('hh')
.directive('mediaThumbnailViewer', ['$sce', function($sce) {
	return {
		restrict: 'E',
		replace: true,
		scope: {
			media: '=media'
		},

		link: function(scope, element, attr) {
			if (typeof attr.media === 'undefined') {
				throw new Error('<media-thumbnail-viewer /> requires `media` attribute.');
			}

			function setUrl(url) {
				if (scope.type === 'image') {
					if (url.indexOf("instagram.com") != -1 && url.lastIndexOf("_n.jpg") != -1) {
						scope.url = url.replace("_n.jpg", "_s.jpg");
					}
					else
						scope.url = url;
				}
				else
					scope.url = $sce.trustAsResourceUrl(url);
			}

			if (scope.media) {
				if (scope.media && scope.media.thumbnail) {
					setUrl(scope.media.thumbnail);
					scope.$watch('media.thumbnail', setUrl);
				}
				else if (scope.media.url) {
					setUrl(scope.media.url);
					scope.$watch('media.url', setUrl);
				}
			}
		},

		template: [
			'<div>',
				'<span ng-if="media.type === \'v\' || media.type === \'y\'" class="icon ion-play"></span>',
				'<img ng-if="media.type === \'i\' || media.type === \'y\' || (media.type === \'v\' && media.thumbnail)" class="left" ng-src="{{url}}" />',
			'</div>',
		].join('')
	};
}]);