angular.module('hh')
.directive('mediaViewer', ['$sce', function($sce) {
	return {
		restrict: 'E',
		replace: true,
		scope: {
			media: '=media'
		},

		link: function(scope, element, attr) {
			if (typeof attr.media === 'undefined') {
				throw new Error('<media-viewer /> requires `media` attribute.');
			}
			var media = attr.media || {};

			scope.type = media.type || 'none';
			scope.url = $sce.trustAsResourceUrl(media.url);
			scope.thumbnail = $sce.trustAsResourceUrl(media.thumbnail);

			scope.$watch('media.type', function(type) {
				if (type)
					scope.type = type;
			});

			scope.$watch('media.url', function(url) {
				scope.url = $sce.trustAsResourceUrl(url);
			});

			scope.$watch('media.thumbnail', function(thumbnail) {
				scope.thumbnail = $sce.trustAsResourceUrl(thumbnail);
			});

			scope.$watch('media.embed', function(html) {
				if (html) {
					var htmlEmbed = html;
					if (html.indexOf("y.") != -1 && html.indexOf("/embed/") != -1 && html.indexOf("?rel=0&showinfo=0") == -1) {
						var indexStart = html.indexOf('/embed/');
						indexStart = indexStart + html.substring(indexStart).indexOf(' ');
						htmlEmbed = html.substring(0, indexStart - 1) + "?rel=0&showinfo=0" + html.substring(indexStart - 1);
					}
					scope.embed = $sce.trustAsHtml(htmlEmbed);
				}
				else
					delete scope.embed;
			});
		},

		template: [
			'<div align="center" style="background-color:black">',
				'<div class="challenge-image"><img ng-if="type === \'i\'" ng-src="{{url}}" /></div>',
				'<div ng-if="type === \'v\' || !!embed" style="height:60px"></div>',
				'<video class="video" style="max-width: 320px; min-height: 320px" controls ng-if="type === \'v\'" ng-src="{{url}}" poster="{{thumbnail}}"></video>',
				'<div class="video-background" ng-if="!!embed" ng-bind-html="embed"></div>',
			'</div>',
		].join('')
	};
}]);