angular.module('hh')

.factory('InstagramService', function($rootScope, $q, $window, $http) {

	var STORAGE_KEY = 'instagramUser';

	var service = {

		clearUser: function() {
				window.localStorage.removeItem(STORAGE_KEY);
		},

		getRecentUser: function() {
			var instagramUser = null;
			try {
				instagramUser = JSON.parse(window.localStorage.getItem(STORAGE_KEY));
			}
			catch(error) {}
			return instagramUser;
		},

		getRecentPhotos: function(username) {
			try {
				window.localStorage.setItem(STORAGE_KEY, JSON.stringify({ username: "@" + username }));
			}
			catch(error) {}
		
			var deferred = $q.defer();
			$http.get('https://www.instagram.com/' + username + '/media/')
			.success(function(data) {
				//console.log(data.items);
				if (data.items)
					deferred.resolve(data.items);
				else
					deferred.reject('Could not find photos for user ' + username);
			})
			.error(function(error) {
				deferred.reject(error);
			});
			return deferred.promise;
		}
	}

	return service;
});